<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>fwAccessControl: Group-manipulation functions</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">fwAccessControl
   &#160;<span id="projectnumber">8.4.4</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('group__GroupFunctions.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">Group-manipulation functions<div class="ingroups"><a class="el" href="group__API.html">Access Control library</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader">Group-related functions</h2></td></tr>
<tr><td class="ititle" colspan="2"><p><a class="anchor" id="amgrpef82e618c139c394e154805af53693ca"></a>see also the module <a class="el" href="group__GroupFunctions.html">Group manipulation functions</a> </p>
</td></tr>
<tr class="memitem:ga9982f3c5f631dcb1bf97d71ceee74ef7"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__GroupFunctions.html#ga9982f3c5f631dcb1bf97d71ceee74ef7">fwAccessControl_getAllGroups</a> (dyn_string &amp;grouplist, dyn_string &amp;fullGroupNames, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ga9982f3c5f631dcb1bf97d71ceee74ef7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga9babf4fab11fb98c59977bafa38ab669"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__GroupFunctions.html#ga9babf4fab11fb98c59977bafa38ab669">fwAccessControl_getGroup</a> (string groupName, string &amp;groupFullName, string &amp;description, int &amp;groupId, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ga9babf4fab11fb98c59977bafa38ab669"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga8a39eefcab8455d1974490b5901b75a1"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__GroupFunctions.html#ga8a39eefcab8455d1974490b5901b75a1">fwAccessControl_deleteGroup</a> (string groupName, dyn_string &amp;exceptionInfo) synchronized(_fwAccessControl_mutex)</td></tr>
<tr class="separator:ga8a39eefcab8455d1974490b5901b75a1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga5f604752671fb2cb93f3ff70ed11f8af"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__GroupFunctions.html#ga5f604752671fb2cb93f3ff70ed11f8af">fwAccessControl_createGroup</a> (string groupName, string groupFullName, string groupComment, dyn_string privileges, dyn_string &amp;exceptionInfo) synchronized(_fwAccessControl_mutex)</td></tr>
<tr class="separator:ga5f604752671fb2cb93f3ff70ed11f8af"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga96f3b73d9c8819043fac868aa2c315e2"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__GroupFunctions.html#ga96f3b73d9c8819043fac868aa2c315e2">fwAccessControl_updateGroup</a> (string groupName, string newGroupName, string groupFullName, string groupComment, dyn_string privileges, dyn_string &amp;exceptionInfo) synchronized(_fwAccessControl_mutex)</td></tr>
<tr class="separator:ga96f3b73d9c8819043fac868aa2c315e2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaadfa4d5ccca092279009e4bcf7cf194a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__GroupFunctions.html#gaadfa4d5ccca092279009e4bcf7cf194a">fwAccessControl_getGroupMembers</a> (string groupName, dyn_string &amp;members, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:gaadfa4d5ccca092279009e4bcf7cf194a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga37e102e7a47c125753f1e30df86f9eab"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__GroupFunctions.html#ga37e102e7a47c125753f1e30df86f9eab">fwAccessControl_resolveGroupsRecursively</a> (dyn_string groupNames, dyn_string &amp;includedGroups, dyn_string &amp;includedBy, dyn_string &amp;exceptionInfo, bool recursive=TRUE)</td></tr>
<tr class="separator:ga37e102e7a47c125753f1e30df86f9eab"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga0fe0f8be6fb4ebf2619fa722aeda0aef"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__GroupFunctions.html#ga0fe0f8be6fb4ebf2619fa722aeda0aef">fwAccessControl_getGroupsInGroup</a> (string groupName, dyn_string &amp;includedGroups, dyn_string &amp;exceptionInfo, bool recursive=FALSE)</td></tr>
<tr class="separator:ga0fe0f8be6fb4ebf2619fa722aeda0aef"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4e040b5dcaa1662f720a82bf75ad201a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__GroupFunctions.html#ga4e040b5dcaa1662f720a82bf75ad201a">fwAccessControl_setGroupsInGroup</a> (string groupName, dyn_string includedGroups, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ga4e040b5dcaa1662f720a82bf75ad201a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<h2 class="groupheader">Function Documentation</h2>
<a id="ga9982f3c5f631dcb1bf97d71ceee74ef7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga9982f3c5f631dcb1bf97d71ceee74ef7">&#9670;&nbsp;</a></span>fwAccessControl_getAllGroups()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwAccessControl_getAllGroups </td>
          <td>(</td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>grouplist</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>fullGroupNames</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>get the list of all groups </p>

</div>
</div>
<a id="ga9babf4fab11fb98c59977bafa38ab669"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga9babf4fab11fb98c59977bafa38ab669">&#9670;&nbsp;</a></span>fwAccessControl_getGroup()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwAccessControl_getGroup </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>groupName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string &amp;&#160;</td>
          <td class="paramname"><em>groupFullName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string &amp;&#160;</td>
          <td class="paramname"><em>description</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int &amp;&#160;</td>
          <td class="paramname"><em>groupId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>get details concerning a group </p>

</div>
</div>
<a id="ga8a39eefcab8455d1974490b5901b75a1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga8a39eefcab8455d1974490b5901b75a1">&#9670;&nbsp;</a></span>fwAccessControl_deleteGroup()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwAccessControl_deleteGroup </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>groupName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>delete a group </p>

</div>
</div>
<a id="ga5f604752671fb2cb93f3ff70ed11f8af"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga5f604752671fb2cb93f3ff70ed11f8af">&#9670;&nbsp;</a></span>fwAccessControl_createGroup()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwAccessControl_createGroup </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>groupName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>groupFullName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>groupComment</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>privileges</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>creates new group </p>

</div>
</div>
<a id="ga96f3b73d9c8819043fac868aa2c315e2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga96f3b73d9c8819043fac868aa2c315e2">&#9670;&nbsp;</a></span>fwAccessControl_updateGroup()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwAccessControl_updateGroup </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>groupName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>newGroupName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>groupFullName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>groupComment</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>privileges</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>modifies a group </p>

</div>
</div>
<a id="gaadfa4d5ccca092279009e4bcf7cf194a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gaadfa4d5ccca092279009e4bcf7cf194a">&#9670;&nbsp;</a></span>fwAccessControl_getGroupMembers()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwAccessControl_getGroupMembers </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>groupName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>members</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>get list of users belonging to a group </p>

</div>
</div>
<a id="ga37e102e7a47c125753f1e30df86f9eab"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga37e102e7a47c125753f1e30df86f9eab">&#9670;&nbsp;</a></span>fwAccessControl_resolveGroupsRecursively()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwAccessControl_resolveGroupsRecursively </td>
          <td>(</td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>groupNames</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>includedGroups</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>includedBy</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>recursive</em> = <code>TRUE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>resolves groups recursively</p>
<p>for a set of groups specified in <code>groupNames</code>, returns the list of groups that are included by them (with recursive processing) and returns their names in the <code>includedGroups</code> ; the <code>includedGroups</code> will include all the entries specified in <code>groupNames</code>. For the subgroups being resolved recursively, the <code>includedBy</code> will contain the name of the "main" groups that include this group; for the "main" groups it will be empty</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">groupNames</td><td>the list of names of the groups, the names of which are to be resolved </td></tr>
    <tr><td class="paramname">includedGroups</td><td>on return, it will contain the names of all groups that specified in groupNames, plus the groups that are included in them; if <code>recursive=TRUE</code>, the included groups will be resolved recursively </td></tr>
    <tr><td class="paramname">includedBy</td><td>on return, for every entry in includedGroups it will either contain an empty string (for groups that were originally specified in <code>groupNames</code>) or the name of the group, that made the entry included in the list; </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling parameter </td></tr>
    <tr><td class="paramname">recursive</td><td>(optional, default TRUE) determines if the group hierarchy should be traversed recursively, so that all children are returned.</td></tr>
  </table>
  </dd>
</dl>
<p>Note that if a group is specified in <code>groupNames</code>, and then it turns out that it is also included by some other group, the <code>includedBy</code> for this group will be empty. </p>

</div>
</div>
<a id="ga0fe0f8be6fb4ebf2619fa722aeda0aef"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga0fe0f8be6fb4ebf2619fa722aeda0aef">&#9670;&nbsp;</a></span>fwAccessControl_getGroupsInGroup()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwAccessControl_getGroupsInGroup </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>groupName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>includedGroups</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>recursive</em> = <code>FALSE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>get groups hierarchy - list of groups included in a group</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">groupName</td><td>the name of the group, for which subgroups are to be returned </td></tr>
    <tr><td class="paramname">includedGroups</td><td>on return, will contain the names of the subgroups included in the group passed in the <code>groupName</code> parameter; note that the group specified in <code>groupName</code> is not returned in <code>includedGroups</code> </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling parameter </td></tr>
    <tr><td class="paramname">recursive</td><td>(optional, default FALSE) specifies if the group hierarchy is to be traversed recursively, i.e. if it should return only the direct children, or also children-of-children and so on </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ga4e040b5dcaa1662f720a82bf75ad201a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga4e040b5dcaa1662f720a82bf75ad201a">&#9670;&nbsp;</a></span>fwAccessControl_setGroupsInGroup()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwAccessControl_setGroupsInGroup </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>groupName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>includedGroups</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>set groups hierarchy - list of groups included in a group</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">groupName</td><td>the name of the group, for which the subgroups are to be set </td></tr>
    <tr><td class="paramname">includedGroups</td><td>the list of groups to be included in the group. </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling parameter</td></tr>
  </table>
  </dd>
</dl>
<p>Note that the function detects circular references, and reports an error in such case (e.g. A includes B and C, C includes D, and D includes A) </p>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1 </li>
  </ul>
</div>
</body>
</html>
